package server

import (
	"gitlab.schukai.com/oss/utilities/conan/configuration"
	"gitlab.schukai.com/oss/utilities/conan/constants"
	"gitlab.schukai.com/oss/utilities/conan/logging"
	"net/http"
	"os"
	"regexp"
	"strings"
)

func injectHandler(next http.Handler) http.Handler {

	fn := func(w http.ResponseWriter, r *http.Request) {

		if strings.HasSuffix(r.URL.Path, ".html") {

			path := configuration.GetServerWebPath() + "/" + r.URL.Path
			logging.LogDebug("Injecting script into %s", path)
			if _, err := os.Stat(path); err != nil {
				next.ServeHTTP(w, r)
				return
			}

			p, err := os.ReadFile(path)
			if err != nil {
				logging.LogError("InjectHandler error %s", err.Error())
				return
			}

			p = injectScript(p)

			w.Header().Set("Content-Type", "text/html")
			w.Write(p)

			return

		}

		next.ServeHTTP(w, r)

	}

	return http.HandlerFunc(fn)

}

//go:generate go run ../../../development/script/inject-js.go
var script string

func init() {

	script = "<script type=\"module\">" +
		strings.Replace(jsTemplate, "{{ constants.WebsocketPath }}", constants.WebsocketPath, -1) +
		"</script><body"

}

func injectScript(p []byte) []byte {

	s := string(p)
	reg := regexp.MustCompile(`<body`)
	s = reg.ReplaceAllString(s, script)

	return []byte(s)

}
