// This script is integrated into the inject_gen.go file using a generator.
// It is not intended to be run directly.
// run go generate to update the inject_gen.go file.

try {
    let died = false;
    let counter = 0;
    let socket
    let url = ""
    if (document.location.protocol == 'https:') {
        url = 'wss://'
    } else {
        url = 'ws://'
    }
    url += document.location.host + "{{ constants.WebsocketPath }}";

    function connectWebsocket() {

        if (socket) {
            socket.close()
        }

        if (counter++ > 20) {
            console.error("Failed 20 times to connect to websocket. Giving up.")
            return
        }

        socket = new WebSocket(url)

        socket.onopen = function (e) {

            if (died === true) {
                window.location.reload();
            }

            console.log("[conan] Connection established");
            counter = 0
        };

        socket.onmessage = function (event) {
            console.log("[conan] Data received from server: " + event?.data);

            if (event?.data == "reload") {
                console.log("[conan] Reloading page")
                window.location.reload();
            }
        };

        socket.onclose = function (event) {
            if (event.wasClean) {
                console.log("[conan] Connection closed cleanly, code=" + event?.code + " reason=" + event?.reason + "");
            } else {
                console.error("[conan] Connection died");
                died = true
                setTimeout(connectWebsocket, 3000 * counter)
            }
        };

        socket.onerror = function (error) {
            console.error("[conan] error", error);
        };

    }

    document.addEventListener("DOMContentLoaded", () => {
        connectWebsocket()
    })

} catch (e) {
    console.error(e)
}


// Language: javascript