package main

import (
	. "github.com/dave/jennifer/jen"
	"github.com/evanw/esbuild/pkg/api"
	"path"
	"path/filepath"
)
import "os"

func main() {

	wd, _ := os.Getwd()
	//file := os.Getenv("GOFILE")

	//p := path.Join(wd, file)
	j := path.Join(wd, "inject.js")

	result := api.Build(api.BuildOptions{
		EntryPoints:       []string{j},
		Bundle:            true,
		MinifyWhitespace:  true,
		MinifyIdentifiers: true,
		MinifySyntax:      true,
		Engines: []api.Engine{
			{api.EngineChrome, "58"},
			{api.EngineFirefox, "57"},
			{api.EngineSafari, "11"},
			{api.EngineEdge, "16"},
		},
		Write: false,
	})

	if len(result.Errors) > 0 {
		os.Exit(1)
	}

	code := ""
	for _, r := range result.OutputFiles {
		code += string(r.Contents)
	}
	//
	//content, err := os.ReadFile(p)
	//if err != nil {
	//	os.Exit(1)
	//}

	//content = []byte(code)

	goPackage := os.Getenv("GOPACKAGE")
	f := NewFile(goPackage)
	f.PackageComment("Code generated by generator, DO NOT EDIT.")

	f.Var().Id("jsTemplate").String().Op("=").Lit(code)

	goFile := os.Getenv("GOFILE")
	ext := filepath.Ext(goFile)
	baseFilename := goFile[0 : len(goFile)-len(ext)]
	targetFilename := baseFilename + "_gen.go"

	f.Save(targetFilename)
}
